﻿var tv_visible=false;
var sPlaying = "Playing";
var sStopped = "Stopped";
var sTrans = "Transitioning";
var sBuffering = "Buffering";
var sPaused = "Paused";
var sWaiting = "Waiting";
var http_request = null;
var g_speed=0;
var g_timer=0;
var g_speed_inc=10;
var g_ScrollPause=false;
var g_scrollHeight=0;
var g_sLabelTracks="Tracks";
var g_sLabelLyrics="Lyrics";
var g_sLabelSpotify="Spotify";
var g_sSpotifyHelp="Click here to search spotify";
var g_sLyricsHelp="Click here to search for lyrics";
var g_sTracksHelp="Click here for tracks";
var g_sGoogleHelp="Click here for google search";
var g_sLastFMHelp="Click here for artist information";
var g_sYoutubeHelp="Click here to search YouTube";
var g_sAmazonHelp="Click here to search Amazon.com";
var g_sItunesHelp="Click here to search iTunes";
var g_sAlbumHelp="Right click for menu";

    var Url = {

      // public method for URL encoding
      encode : function (string) {
         return escape(this._utf8_encode(string));
      },

      // public method for URL decoding
       decode : function (string) {
        return this._utf8_decode(unescape(string));
      },

      // private method for UTF-8 encoding
      _utf8_encode : function (string) {
          string = string.replace(/\r\n/g,"\n");
        var utftext = "";

          for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
          } else if((c > 127) && (c < 2048)) {
              utftext += String.fromCharCode((c >> 6) | 192);
              utftext += String.fromCharCode((c & 63) | 128);
          } else {
              utftext += String.fromCharCode((c >> 12) | 224);
              utftext += String.fromCharCode(((c >> 6) & 63) | 128);
            utftext += String.fromCharCode((c & 63) | 128);
          }
      }

        return utftext;
      },

      // private method for UTF-8 decoding
      _utf8_decode : function (utftext) {
         var string = "";
         var i = 0;
         var c = c1 = c2 = 0;

          while ( i < utftext.length ) {
             c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
             } else if((c > 191) && (c < 224)) {
               c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
             } else {
               c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
               i += 3;
            }
          }
        return string;
       }
    }
    function getQueryParam( name )
    {
      name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
      var regexS = "[\\?&]"+name+"=([^&#]*)";
      var regex = new RegExp( regexS );
      var results = regex.exec( window.location.href );
      if( results == null )
        return "";
      else
        return Url.decode(results[1]);
    }   
    //<![CDATA[
    var searchControl;
    google.load("search", "1");

    function InitGoogleSearch() {
    try
    {
      // Create a search control
      searchControl = new google.search.SearchControl();

      var video_options = new google.search.SearcherOptions();
      var image_options = new google.search.SearcherOptions();
      var web_options = new google.search.SearcherOptions();
      
      video_options.setRoot(document.getElementById("id_videos"));
      video_options.setExpandMode(google.search.SearchControl.EXPAND_MODE_OPEN);
      web_options.setRoot(document.getElementById("id_web"));
      web_options.setExpandMode(google.search.SearchControl.EXPAND_MODE_OPEN);
      image_options.setRoot(document.getElementById("id_images"));
      image_options.setExpandMode(google.search.SearchControl.EXPAND_MODE_OPEN);
      // Add in a full set of searchers
      var videoSearch = new google.search.VideoSearch();
      var imgSearch = new google.search.ImageSearch();
      var webSearch = new google.search.WebSearch();
      searchControl.addSearcher(videoSearch,video_options);
      searchControl.addSearcher(webSearch,web_options);
      searchControl.addSearcher(imgSearch,image_options);

      searchControl.setResultSetSize(google.search.Search.SMALL_RESULTSET); 
      // Tell the searcher to draw itself and tell it where to attach
      var drawOptions = new google.search.DrawOptions();
      //drawOptions.setDrawMode(google.search.SearchControl.DRAW_MODE_TABBED);
      searchControl.draw(document.getElementById("id_google_search"), drawOptions);
  
      // Execute an inital search
      var text=getQueryParam("q");
      if (text.length > 0)
          searchControl.execute(text);
     }
     catch(e)
     {
     //alert(e.message);
     }
    }
    //]]>
    function StartGoogleSearch(text)
    {
       g_CurrGoogleSearch=text;
       searchControl.execute(text);        
    }

function OnInit()
{
	//alert("OnInit");
    //InitGoogleSearch();
	SetElementToolTip('idLyricsImg',g_sLyricsHelp);
	SetElementToolTip('idLastFMImg',g_sLastFMHelp);
	SetElementToolTip('idAmazonImg',g_sAmazonHelp);
	SetElementToolTip('idYouTubeImg',g_sYoutubeHelp);
	SetElementToolTip('idItunesImg',g_sItunesHelp);	
	SetElementToolTip('idSpotifyImg',g_sSpotifyHelp);	
}

function clientSideInclude(id, url)
{
 var element = document.getElementById(id);
 if (!element) {
  alert("Bad id " + id +
   "passed to clientSideInclude." +
   "You need a div or span element " +
   "with this id in your page.");
  return;
  }
  element.innerHTML="<b>Loading...</b>";
  var req = null;
  // For Safari, Firefox, and other non-MS browsers
  if (window.XMLHttpRequest) {
    try {
      req = new XMLHttpRequest();
    } catch (e) {
      req = false;
    }
  } else if (window.ActiveXObject) {
    // For Internet Explorer on Windows
    try {
      req = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      try {
        req = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {
        req = false;
      }
    }
 }
 try
 {
    if (req) {
      // Synchronous request, wait till we have it all
      req.open('GET', url, false);
      req.send();
      element.innerHTML = req.responseText;
    }
    else 
    {
      element.innerHTML = "Sorry, your browser does not support XMLHTTPRequest objects. This page requires IE5 or better or another compatible browser.";
    }
}
catch(e)
{
  element.innerHTML = e.message;
}
}

function getHttpRequest()
{
    var newReq = null;
    if(window.XMLHttpRequest) {
      try {
        newReq = new XMLHttpRequest();
      }
      catch(e) {
        newReq = false;
      }
    }
    else if(window.ActiveXObject) {
      try {
        newReq = new ActiveXObject("Msxml2.XMLHTTP");
      }
      catch(e) {
        try {
           newReq = new ActiveXObject("Microsoft.XMLHTTP");
        }
        catch(e) {
          newReq = false;
        }
      }
    }
    return newReq;
 }


 function makeHttpRequest(getpost,url,postdata) 
 {
    if(http_request==null) {
      http_request = getHttpRequest();
    }
  else if(http_request){
           http_request.abort();
	}
    if(http_request) {
        http_request.onreadystatechange = http_ready;
        http_request.open(getpost, url, true);
      if (getpost == "GET")
      {
        http_request.send("");
      }
      else
      {
        http_request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        http_request.send(postdata);
      } 
    }
    else{
      alert("The XMLHttpRequest Object is not supported");
    }
}

/*
function makeRequest(getpost,url,postdata) 
{
    http_request = false;
    if (window.XMLHttpRequest) 
    { // Mozilla, Safari,...
        http_request = new XMLHttpRequest();
        if (http_request.overrideMimeType) 
        {
            http_request.overrideMimeType('text/xml');
        }
    } 
    else if (window.ActiveXObject) 
    { // IE
        try 
        {
            http_request = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) 
        {
            try 
            {
            http_request = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {}
        }
    }

    if (!http_request) 
    {
        return false;
    }
    http_request.onreadystatechange = http_ready;
    http_request.open(getpost, url, true);
    if(getpost == "GET")
    {
        http_request.send(null);
    }
    else
    {
        http_request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        http_request.send(postdata);
    }

}
*/

function http_ready()
{
  if (http_request == null)
      return;
    if (http_request.readyState == 4) 
    {
        if (http_request.status == 200) 
        {    
        alert(http_request.responseText);        
        }
    }
} 

function SendNowPlaying(url,postdata)
{    
    makeHttpRequest("POST",url,postdata);
}

function ScrobbleSong(url,postdata)
{     
    makeHttpRequest("POST",url,postdata);
}

function SetPlayingText(s)
{
  sPlaying=s;
}
function SetStoppedText(s)
{
  sStopped=s;
}
function SetTransText(s)
{
  sTrans=s;
}
function SetBufferingText(s)
{
  sBuffering=s;
}
function SetPausedText(s)
{
  sPaused=s;
}
function SetWaitingText(s)
{
  sWaiting=s;
}
function OnAlbumClick()
{
  window.location.href = "http://main_info_album_click";
}

function SetGoogleSearch(s)
{
   StartGoogleSearch(s);
}
function SetElementToolTip(elem_id,tt)
{
   var elem = document.getElementById(elem_id);
	if (elem == null)
		return;
   elem.getAttributeNode("title").value=tt;
}
function HideLyrics()
{
   var elemLyrics = document.getElementById('div_lyrics');
	if (elemLyrics == null)
		return;
   elemLyrics.style.display="none";
}
function ShowLyrics()
{
   var elemLyrics = document.getElementById('div_lyrics');
	if (elemLyrics == null)
		return;
   elemLyrics.style.display="block";
}
function ShowElement(elem_id)
{
   var elem = document.getElementById(elem_id);
	if (elem == null)
		return;
   elem.style.display="block";
}
function HideElement(elem_id)
{
   var elem = document.getElementById(elem_id);
	if (elem == null)
		return;
   elem.style.display="none";
}
function SwitchToTV()
{
  if (tv_visible)
      return;
    try
    {
        tv_visible=true;
        var style1 = document.getElementById('divAlbum').style;
        var style2 = document.getElementById('divPlayer').style;
        style1.display="none";
        style2.display="block";
    }
    catch(ex)
    {
    alert(ex.message);
    }
}
function SwitchToAlbum()
{
  if (!tv_visible)
      return;
    try
    {
        tv_visible=false;
        var style1 = document.getElementById('divAlbum').style;
        var style2 = document.getElementById('divPlayer').style;
        style1.display="block";
        style2.display="none";
    }
    catch(ex)
    {
    alert(ex.message);
    }
}
function Mute(m)
{
    VIDEO.settings.mute=m;
}
function Stop()
{
    VIDEO.controls.stop();
}
function Play(url)
{
    VIDEO.URL = url;
    VIDEO.controls.play();
}
function SetVolume(n)
{
	VIDEO.settings.Volume=n;
}
function Init()
{
}
function WMP_Buffering(start) 
{
var info = document.getElementById("idBitrate");
if (start)
{
			info.innerText = sBuffering;
}
else
{
      info.innerText = "";
}
}
function WMP_StatusChange() 
{
	if (tv_visible == false || VIDEO.currentMedia == null)
		return;

 var info = document.getElementById("idInfo");
  info.innerText = VIDEO.status;
}
function WMP_PlayStateChange(a) 
{
	if (tv_visible == false || VIDEO.currentMedia == null)
		return;

	switch (a)
	{
		case 3:	//playing
    var info = document.getElementById("idBitrate");
		info.innerText = Math.round(VIDEO.network.bitRate/1000) + " kbps";
			break;
	}
}

function SetLyricsHelp(s)
{
	g_sLyricsHelp=s;
}

function SetTracksHelp(s)
{
	g_sTracksHelp=s;
}

function SetAlbumHelp(s)
{
	g_sAlbumHelp=s;
}

function SetGoogleHelp(s)
{
	g_sGoogleHelp=s;
}

function ShowControlPanel(show)
{
    var cp=document.getElementById("divControlPanel");
    if (cp == null)
        return;
    if (show)      
        cp.style.display="block";
    else
        cp.style.display="none";    
}

function ShowAlbumCover(show,left,lyricspos)
{
    var album=document.getElementById("divAlbum");
	if (album == null)
		return;
	var info=document.getElementById("divInfo");
    if (show)
    {
       album.style.display="block";
		if (info != null)
		{
			info.style.left = left;
		}
    }  
    else
    {
       album.style.display="none";
		if (info != null)
		{
			info.style.left = left;
		}
    }
	if (lyricspos > 0)
	{
		var lyrics=document.getElementById("div_lyrics");
		var percent = lyricspos+"%";
		if (lyrics != null)
		{
			lyrics.style.left = percent;
		}
	}
}

function onmouseover_addfav(elem)
{
    elem.src="star.png";
}

function onmouseout_addfav(elem)
{
    elem.src="star_blank.png";
}

function onmouseovertracks()
{
	window.status=g_sLyricsHelp;
}

function onmouseouttracks()
{
	window.status="";
}

function onmouseoveralbum()
{
	window.status=g_sAlbumHelp;
  var album=document.getElementById("idAlbum");
	if (album != null)
	{
      album.style.cursor="hand";
	}
}

function onmouseovertracksimage()
{
	window.status=g_sTracksHelp;
}

function onmouseoverlyricsimage()
{
	window.status=g_sLyricsHelp;
}

function onmouseovergoogleimage()
{
	window.status=g_sGoogleHelp;
}

function onmouseoveryoutubeimage()
{
	window.status=g_sYoutubeHelp;
}

function onmouseoverspotifyimage()
{
	window.status=g_sSpotifyHelp;
}

function onmouseoveramazonimage()
{
	window.status=g_sAmazonHelp;
}

function onmouseoveritunesimage()
{
	window.status=g_sItunesHelp;
}

function onmouseoutalbum()
{
	window.status="";
}
 
function onclicktracks()
{
  SetTracks(1);
  var url="http://tracks_click";
  window.location.href = url;
}
function onclicklyrics()
{
  SetTracks(2);
  var url="http://lyrics_click";
  window.location.href = url;
}

function onclickgoogle()
{
  SetTracks(3);
  var url="http://google_click";
  window.location.href = url;
}

function onclickyoutube()
{
  SetTracks(4);
  var url="http://youtube_click";
  window.location.href = url;
}

function onclickamazon()
{
  SetTracks(4);
  var url="http://amazon_click";
  window.location.href = url;
}

function onclickitunes()
{
  SetTracks(4);
  var url="http://itunes_click";
  window.location.href = url;
}

function onclickspotify()
{
  SetTracks(4);
  var url="http://spotify_click";
  window.location.href = url;
}

function SetTracksLabel(sLyrics,sTracks)
{
    g_sLabelLyrics=sLyrics;
    g_sLabelTracks=sTracks;
}
function IsTracksVisible()
{
    var elem=document.getElementById("idTracks");
    if (elem == null)
         return false;
    return elem.style.display != "none";    
}
function IsLyricsVisible()
{
    var elem=document.getElementById("idLyrics");
    if (elem == null)
         return false;
    return elem.style.display != "none";    
}
function IsGoogleVisible()
{
    var elem=document.getElementById("id_google_search");
    if (elem == null)
         return false;
    return elem.style.display != "none";    
}

function SetTracks(show)
{
  try
  {
    var labelTracks=null; //document.getElementById("idLabelTracks");
    var elem_tracks=null; //document.getElementById("idTracks");
    var elem_lyrics=document.getElementById("idLyrics");
    var elem_search=document.getElementById("id_google_search");
    var elem_web=document.getElementById("id_web");
    var elem_videos=document.getElementById("id_videos");
    var elem_images=document.getElementById("id_images");
    var display_lyrics;
    var display_tracks;
    var display_google;
    // 1=tracks
    // 2=lyrics
    // 3=google
    if (show == 1)
    {	
      display_tracks="block";
      display_lyrics="none";
      display_google="none";
      if (labelTracks != null)
          idLabelTracks.innerText=g_sLabelTracks;
    }  
    else if (show == 2)
    {
      display_lyrics="block";
      display_tracks="none";
      display_google="none";
      if (labelTracks != null)
          idLabelTracks.innerText=g_sLabelLyrics;
    }
    else if (show == 3)
    {
      display_google="block";
      display_tracks="none";
      display_lyrics="none";
    }
    else
    {
      return;
    }
	if (elem_tracks != null)
     	elem_tracks.style.display=display_tracks;
	if (elem_lyrics != null)	
     	elem_lyrics.style.display=display_lyrics;
	if (elem_search != null)	
     	elem_search.style.display=display_google;
     if (elem_web != null)
        elem_web.style.display=display_google;
     if (elem_videos != null) 
        elem_videos.style.display=display_google;
     if (elem_images != null) 
        elem_images.style.display=display_google;
   }
  catch(e)
  {
    alert(e.message);
  }
}
function FindAlbumCover()
{
	var temp=idArtist.innerText;
	var info = temp.split(" - ");
	if (info.length >= 2)
	{
		fetch_from_google(info[0],info[1]);
	}
	else 
	{
		fetch_from_google(temp,"");
	}
}
function OnLyricsMouseOver()
{
    g_ScrollPause = true;
}

function OnLyricsMouseOut()
{
    g_ScrollPause = false;
	window.status="";
}

function StartScrollLyrics(timer_interval,speed_inc)
{
   if (g_timer==0)
   {
       if (timer_interval == 0)
           timer_interval=4000;
       g_timer=setInterval("ScrollWindow()",timer_interval);
   }
   g_speed=0;
   if (speed_inc==0)
       speed_inc=10;
   g_speed_inc=speed_inc;
   window.scrollTo(0,0);
   g_scrollHeight = document.body.scrollHeight;
}

function StopScrollLyrics()
{
    if (g_timer!=0)
    {
        clearInterval(g_timer);
	g_timer=0;
     }
}

function ScrollWindow()
{
   if (g_ScrollPause)
       return;
   if (g_speed >= g_scrollHeight)
	return;
   g_speed+=g_speed_inc;
   if (g_speed > 2000)
	g_speed=0;
   window.scrollTo(0,g_speed);
}

