﻿var tv_visible=false;
var sPlaying = "Playing";
var sStopped = "Stopped";
var sTrans = "Transitioning";
var sBuffering = "Buffering...";
var sPaused = "Paused";
var sWaiting = "Waiting";
var g_state=0;
var g_url="";
var g_init=false;

function SetPlayingText(s)
{
  sPlaying=s;
}
function SetStoppedText(s)
{
  sStopped=s;
}
function SetTransText(s)
{
  sTrans=s;
}
function SetBufferingText(s)
{
  sBuffering=s;
}
function SetPausedText(s)
{
  sPaused=s;
}
function SetWaitingText(s)
{
  sWaiting=s;
}
function Mute(m)
{
    var player=document.getElementById("VIDEO");
    if (player != null)
    {
        player.settings.mute=m;
        SetMuteImage(m);
    }
}
function Stop()
{
    var player=document.getElementById("VIDEO");
    if (player != null)
    {
		player.controls.stop();
	}
}
function Play(url)
{
	if (url != "")
		g_url=url;
	if (g_url == "")
		return;
    var player=document.getElementById("VIDEO");
    if (player != null)
    {
		player.URL = g_url;
		player.controls.play();
	}
}
function SetVolume(n)
{
	VIDEO.settings.Volume=n;
}
function SetURL(url)
{
    g_url = url;
	if (g_init)
		Play("");
}
function Init()
{
	g_init=true;
	Play("");
	//Play("mms://live1.wm.skynews.servecast.net/skynews_wmlz_live300k");
}
function WMP_Buffering(start)
{
    divInfo.innerText = VIDEO.status;
}
function WMP_StatusChange()
{
	if (VIDEO.currentMedia == null)
		return;

    divInfo.innerText = VIDEO.status;
}
function WMP_PlayStateChange(a)
{
	if (VIDEO.currentMedia == null)
		return;

//0 Undefined Windows Media Player is in an undefined state.
//1 Stopped Playback of the current media item is stopped.
//2 Paused Playback of the current media item is paused. When a media item is paused, resuming playback begins from the same location.
//3 Playing The current media item is playing.
//4 ScanForward The current media item is fast forwarding.
//5 ScanReverse The current media item is fast rewinding.
//6 Buffering The current media item is getting additional data from the server.
//7 Waiting Connection is established, but the server is not sending data. Waiting for session to begin.
//8 MediaEnded Media item has completed playback.
//9 Transitioning Preparing new media item.
//10 Ready Ready to begin playing.
//11 Reconnecting
	switch (a)
	{
		case 3:	//playing
		divInfo.innerText = Math.round(VIDEO.network.bitRate/1000) + " kbps";
        imgPlay.src="images/stop.png";
        imgPlay.title="Stop";
		break;
        case 2:
        case 7:
        imgPlay.src="images/play.png";
        imgPlay.title="Play";
        break;
	}
    g_state=a;
}
