﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class RadioPlayer : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string url = Request.Params["station_url"];
        string name = Request.Params["station_name"];
        string id = Request.Params["station_id"];
        if (!string.IsNullOrEmpty(url))
        {
            string script_name = "PlayRadio";
            if (!Page.ClientScript.IsStartupScriptRegistered(script_name))
            {
                string script = string.Format("loadRadio('{0}','{1}');", url, name);
                //string script = string.Format("showURL(\"{0}\",\"{1}\");", url, name);

                Page.ClientScript.RegisterStartupScript(this.GetType(), script_name, script, true);
            }
        }
        if (!string.IsNullOrEmpty(id))
        {
            imgLogo.Width = 128;
            imgLogo.Height = 56;
            imgLogo.ImageUrl = string.Format("http://www.raimasoft.net/images/logos/{0}.jpg", id);
        }
        //
    }
}
