﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="RadioPlayer.aspx.cs" Inherits="RadioPlayer" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
<title>RarmaRadio - Real Player</title> 
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /> 
<link href="radio.css" rel="stylesheet" type="text/css" title="default" /> 
<script type="text/javascript" src="jquery.pack.js" charset="utf-8"></script> 
<script type="text/javascript" src="jquery.getUrlParam.js" charset="utf-8"></script> 
<script type="text/javascript" src="ui.core.js" charset="utf-8"></script> 
<script type="text/javascript" src="ui.slider.js" charset="utf-8"></script>     
<script type="text/javascript">
    var reloadTimeout = null;
    function showURL(url,title)
    {
         alert(url);
    }
    function loadRadio(url, titolo) 
    {
        //alert(url);
        if ($('#lives').length > 0) 
        {
            document.lives.SetSource(url);
            document.lives.DoPlay();
        } 
        else 
        {
            var realZ = '<embed width="150" height="25" name="live" id="lives" TYPE="audio/x-pn-realaudio-plugin" src="' + url + '" CONTROLS="StatusBar" center="true" autostart="true" NOLOGO="true" CONSOLE="one" />';
            $('.realStream').html(realZ);
            //alert('1 '+document.lives);
            //alert('2 '+($('#lives').get(0) == document.lives));
            if (document.lives == null) 
            {
                document.lives = $('#lives').get(0);
                //alert('3 '+document.lives);
            }
        }
        $('.Display h2').text(titolo);
        $('.controlliPlay .Play').css({ backgroundPosition: '0px 0px' });
        return false;
    }

    function setRollOverRadio() {
        var li = $(".Channels ul li");
        li.click(function() {
            li.removeClass('selected');
            $(this).addClass('selected');
        });
    }
    function moveSelection(offset) {
        var lis = $(".Channels ul li");
        var count = lis.length;
        var curr = 0;
        lis.each(function(i) { if ($(this).is('.selected')) curr = i; });
        curr = (count + curr + offset) % count;
        var n = $(lis.get(curr));
        $('a', n).click();
        n.click();
    }

    function changeTitle(title) {
        title = title.replace(/&#39;/g, "'");
        document.title = title;
    }
    var url = decodeURIComponent($(document).getUrlParam("v"));
    //var url = 'http://www.radio.rai.it/live/radio2.ram';
    var titolo = decodeURIComponent(decodeURIComponent($(document).getUrlParam("t")));
    var RPStatus = { STOPPED: 0, CONTACTING: 1, BUFFERING: 2, PLAYING: 3, PAUSED: 4, SEEKING: 5 };

    var DEBUG = false;
    function debug(a) {
        if (typeof (a) == 'undefined') {
            alert('undefined');
        } else if (typeof (a) == 'string') {
            alert(typeof (a) + ': ' + a);
        } else if (typeof (a) == 'object') {
            var s = '';
            for (i in a) s += '[' + i + ']: ' + a[i] + '\n';
            alert(typeof (a) + ': ' + s);
        } else {
            alert(typeof (a) + ': ' + a);
        }
    }
    function sliderUpdated(e, ui) {
        if (!ui || ui === '') {
            ui = $('.Volume').slider('ui');
            if (ui['value'] == null) {
                return;
            }
        }

        document.lives.SetVolume(100 - ui.value);
        // posiziona lo sfondo dello slider
        var slider = $('.contVolume .ui-slider');
        var handler = $('.contVolume .ui-slider-handle');
        var top = handler.position().top + handler.height() / 2;
        slider.css({ backgroundPosition: 'left ' + top + 'px' });
    }

    $(document).ready(function() {

        // $('.Display h2').html(titolo);
        $('.Volume').slider({ steps: 10, range: false, change: sliderUpdated });
        $('.Volume').bind('slide', sliderUpdated);

        // gestione del tasto play/stop
        $('.controlliPlay .Play').click(
		function() {
		    var p = document.lives;
		    if (p.GetPlayState() == RPStatus.STOPPED) {
		        p.DoPlay();
		        //$('.controlliPlay .Play').animate({backgroundPosition: '0px -50px'}, 1500);
		        $(this).css('backgroundPosition', '0px -50px');
		    } else {
		        p.DoStop();
		        //$('.controlliPlay .Play').animate({backgroundPosition: '0px -150px'}, 1500);
		        $(this).css('backgroundPosition', '0px -150px');
		    };
		    $(this).triggerHandler('hover');
		    return false;
		}
	);
        $('.controlliPlay .Play').hover(
		function() { var p = document.lives; if (p.GetPlayState() == RPStatus.STOPPED) { $(this).css('backgroundPosition', '0px -150px'); } else { $(this).css('backgroundPosition', '0px -50px'); } },
		function() { var p = document.lives; if (p.GetPlayState() == RPStatus.STOPPED) { $(this).css('backgroundPosition', '0px -100px'); } else { $(this).css('backgroundPosition', '0px 0px'); } }
	);

        // gestione dei pulsanti destra/sinistra
        $('.controlliPlay .Indietro').click(function() { moveSelection(-1); });
        $('.controlliPlay .Avanti').click(function() { moveSelection(1); });
    });  
 
 
</script> 
</head>
<body>
    <form id="form1" runat="server">
    <div>
<div class="radioPiccola"> 
	<div class="controlliPlay"> 
		<a href="#" title="Indietro" class="Indietro"></a> 
		<a href="#" title="Avanti" class="Avanti"></a> 
		
		<a href="#" title="Play" class="Play"></a> 
	</div> 
 
	<div class="contVolume"> 
		<div class="Volume"></div>	
		<div class="maskVolume"></div> 
	</div>	
	<div class="Info"> 
		<div class="Display"> 
			<div class="icons"> 
				<div class="icoLive"><span class="solotesto">Live</span></div> 
				<div class="icoGraph"></div> 
 
			</div> 
			<h2>Radio</h2> 
			<div class="mask"></div> 
			<div class="realStream"></div> 
		</div> 
	</div>		 
	<div class="radioLogo"><asp:Image ID="imgLogo" runat="server"/></div>
</div> 
    </div>
    </form>
</body>
</html>
